/*
 * Copyright (c) 1996, 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 */

#ifndef __flick_pres_mig_h
#define __flick_pres_mig_h

#include <flick/pres/all.h>
#include <mach.h>
#include <mach/boolean.h>
#include <mach/port.h>
#include <mach/mach_port.h>
#include <mach/message.h>

typedef boolean_t flick_server_t(mach_msg_header_t *InHeadP,
				 mach_msg_header_t *OutHeadP);


/*
 * XXX --- The function `rtSetArgDefaults' in `fe/mig/routine.c' uses these.
 * Should we just use the `local' and `remote' stuff directly?
 */
#define msgh_request_port		msgh_local_port
#define MACH_MSGH_BITS_REQUEST(bits)	MACH_MSGH_BITS_LOCAL(bits)
#define msgh_reply_port			msgh_remote_port
#define MACH_MSGH_BITS_REPLY(bits)	MACH_MSGH_BITS_REMOTE(bits)


/******************************************************************************
 ******************************************************************************
 ****
 **** Memory allocation/deallocation
 ****
 ******************************************************************************
 *****************************************************************************/

#define mach_vm_flick_alloc(_size)					\
(									\
	{vm_address_t __addr;						\
	if (vm_allocate(mach_task_self(), (vm_address_t *) &__addr,	\
			(_size), 1))					\
		return _return;						\
	(void*)__addr;}							\
)

#define mach_vm_flick_free(_addr, _size)				\
{									\
	if (vm_deallocate(mach_task_self(), (vm_address_t)(_addr),	\
			  (_size)))					\
		return _return;						\
}

#define auto_port_allocate(a)						\
{									\
	struct flick_port_list *_top =					\
		alloca(sizeof(struct flick_port_list));			\
	_top->next = _stream->ports_to_free;				\
	_top->p = (a);							\
	_stream->ports_to_free = _top;					\
}


/******************************************************************************
 ******************************************************************************
 ****
 **** Environment and error handling.
 ****
 ******************************************************************************
 *****************************************************************************/

#define flick_mig_init_environment()

#define flick_mig_encode_system_exception(loc, ENCNAME, LINKNAME)	\
{									\
	/*WRITE ME*/							\
}

#define flick_mig_decode_system_exception(loc, ENCNAME, LINKNAME)	\
{									\
	/*WRITE ME*/							\
}

#define flick_mig_encode_client_error(_retname, _errval, ENCNAME, LINKNAME) \
{									  \
	/*WRITE ME*/							\
	_retname;							  \
}

#define flick_mig_encode_server_error(_retname, _errval, ENCNAME, LINKNAME) \
{									  \
	/*WRITE ME*/							\
	_retname;							  \
}

#define flick_mig_decode_client_error(_retname, _errval, ENCNAME, LINKNAME) \
{									  \
	/*WRITE ME*/							\
	_retname;							  \
}

#define flick_mig_decode_server_error(_retname, _errval, ENCNAME, LINKNAME) \
{									  \
	/*WRITE ME*/							\
	_retname;							  \
}

/*****************************************************************************/

#endif /* __flick_pres_mig_h */

/* End of file. */

