/*
 * Copyright (c) 1996, 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 */

#ifndef _iiop_link_h
#define _iiop_link_h

/* will be set to 1 for little_endian, or 0 for big_endian */
extern char flick_is_little_endian;

#include <stdio.h>
#include <stdlib.h>
#include <flick/link/iiop.h>
#include <flick/pres/corba.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/errno.h>
#include <sys/time.h>
#if HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <netinet/in.h>
#include <unistd.h>

#ifndef PACKET_SIZE
#define PACKET_SIZE 65000
#endif

#ifndef SOCKET_BUF_SIZE
#define SOCKET_BUF_SIZE 65536
#endif

#define t_malloc(type, count) (type *)malloc(count * sizeof(type))
#define t_calloc(type, count) (type *)calloc(count, sizeof(type))
#define t_realloc(ptr, type, count) (type *)nonposix_realloc(ptr, count * sizeof(type))

#define swap_long(val)				\
	((((val) & 0x000000FFU) << 24) |	\
	 (((val) & 0x0000FF00U) <<  8) |	\
	 (((val) & 0x00FF0000U) >>  8) |	\
	 (((val) & 0xFF000000U) >> 24))

#define swap_short(val) ((val) >> 8 | (val) << 8)

#endif /* _iiop_link_h */

/* End of file. */

